package com.drht.datamanage.exception;



/**
 * 自定义异常
 * @author chaixueteng
 */
public class CommonException extends RuntimeException {
    private int errorCode;
    private String msg;

    public CommonException(ResultCode errorCode) {
        super(errorCode.getInfo());
        this.errorCode = errorCode.getCode();
        this.msg = errorCode.getInfo();
    }

    public CommonException(ResultCode errorCode, String msg) {
        super(msg);
        this.errorCode = errorCode.getCode();
        this.msg = msg;
    }

    public CommonException(int errorCode, String msg) {
        super(msg);
        this.errorCode = errorCode;
        this.msg = msg;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public int getErrorCode() {
        return errorCode;
    }

    public void setErrorCode(int errorCode) {
        this.errorCode = errorCode;
    }

    /**
     * 重新异常堆栈信息处理,避免遍历堆栈资源浪费,提供性能
     * @return a reference to this {@code Throwable} instance.
     * @see Throwable#printStackTrace()
     */
    @Override
    public synchronized Throwable fillInStackTrace() {
        return this;
    }
}
