package com.drht.datamanage.protocols;

import com.drhb.base.result.BaseResult;
import com.drht.datamanage.model.RealTimeData;
import com.drht.datamanage.model.msg.SendMsg;
import com.drht.datamanage.service.RealTimeDataService;
import com.drht.datamanage.service.Reply;
import com.drht.datamanage.util.AnalysisUtil;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelHandlerContext;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.*;

/**
 * 实时数据
 */
@Service
@Slf4j
public class Cn2011 implements Reply {
    @Autowired
    private RealTimeDataService realTimeDataService;

    @Override
    public void rese(AnalysisUtil.Msg msg, ChannelHandlerContext ctx) throws ParseException {
        SendMsg sendMsg=new SendMsg();
        sendMsg.setQN(msg.getQN());
        sendMsg.setCN("9014");
        sendMsg.setPW(msg.getPW());//暂时写死
        sendMsg.setMN(msg.getMN());
        sendMsg.setFlag("4");
        sendMsg.setST("91");
        List<Map<String,Object>> CP=new ArrayList<>();
        Map cpMap=new HashMap();
        cpMap.put("QnRtn","1");
        CP.add(cpMap);
        sendMsg.setCP(CP);
        //编码报文
        String s = AnalysisUtil.KvToMsg(sendMsg,";");
        //回复消息
        ChannelFuture channelFuture = ctx.writeAndFlush(s);
        //实时数据入库
        Set set = msg.getCP().keySet();
        RealTimeData realTimeData=new RealTimeData();
        for (Object cpkey:set){
            String ckey=(String)cpkey;
            String v = (String) msg.getCP().get(ckey);
            if(ckey.startsWith("w21007-Rtd"))
                realTimeData.setF_nitrate(v);
            else if(ckey.equals("w01012-Rtd"))
                realTimeData.setF_tss(v);
            else if(ckey.equals("w01018-Rtd"))
                realTimeData.setF_cod(v);
            else if(ckey.equals("w01020-Rtd"))
                realTimeData.setF_toc(v);
            else if(ckey.equals("w01019-Rtd"))
                realTimeData.setF_permanganate_index(v);
            else if(ckey.equals("w01003-Rtd"))
                realTimeData.setF_turbidity(v);
            else if(ckey.equals("DataTime"))
                realTimeData.setF_time(v);
            else if(ckey.equals("rawData"))
                realTimeData.setF_raw_data(v);
        }
        BaseResult result=realTimeDataService.insert(realTimeData);
        log.info("保存实时数据结果={}",result);
    }
}
