package com.drht.datamanage.protocols;

import com.drhb.base.result.BaseResult;
import com.drht.datamanage.model.MinuteData;
import com.drht.datamanage.model.RealTimeData;
import com.drht.datamanage.model.msg.SendMsg;
import com.drht.datamanage.service.MinuteDataService;
import com.drht.datamanage.service.Reply;
import com.drht.datamanage.util.AnalysisUtil;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelHandlerContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.*;

/**
 * 分钟数据
 */
@Service
@Slf4j
public class Cn2051 implements Reply {
    @Autowired
    private MinuteDataService minuteDataService;

    @Override
    public void rese(AnalysisUtil.Msg msg, ChannelHandlerContext ctx) throws ParseException {
        SendMsg sendMsg=new SendMsg();
        sendMsg.setQN(msg.getQN());
        sendMsg.setCN("9014");
        sendMsg.setPW(msg.getPW());//暂时写死
        sendMsg.setMN(msg.getMN());
        sendMsg.setFlag(msg.getFlag());
        sendMsg.setST("91");
        List<Map<String,Object>> CP=new ArrayList<>();
        Map cpMap=new HashMap();
        cpMap.put("ExeRtn","1");
        CP.add(cpMap);
        sendMsg.setCP(CP);
        //编码报文
        String s = AnalysisUtil.KvToMsg(sendMsg,";");
        //回复消息
        ChannelFuture channelFuture = ctx.writeAndFlush(s);
        //分钟数据入库
        Set set = msg.getCP().keySet();
        MinuteData minuteData=new MinuteData();
        for (Object cpkey:set){
            String ckey=(String)cpkey;
            String v = (String) msg.getCP().get(ckey);
            if(ckey.equals("w21007-Min"))
                minuteData.setF_nitrate_min(v);
            else if(ckey.equals("w01012-Min"))
                minuteData.setF_tss_min(v);
            else if(ckey.equals("w01018-Min"))
                minuteData.setF_cod_min(v);
            else if(ckey.equals("w01020-Min"))
                minuteData.setF_toc_min(v);
            else if(ckey.equals("w01019-Min"))
                minuteData.setF_permanganate_index_min(v);
            else if(ckey.equals("w01003-Min"))
                minuteData.setF_turbidity_min(v);
            else if(ckey.equals("w21007-Avg"))
                minuteData.setF_nitrate_avg(v);
            else if(ckey.equals("w01012-Avg"))
                minuteData.setF_tss_avg(v);
            else if(ckey.equals("w01018-Avg"))
                minuteData.setF_cod_avg(v);
            else if(ckey.equals("w01020-Avg"))
                minuteData.setF_toc_avg(v);
            else if(ckey.equals("w01019-Avg"))
                minuteData.setF_permanganate_index_avg(v);
            else if(ckey.equals("w01003-Avg"))
                minuteData.setF_turbidity_avg(v);
            else if(ckey.equals("w21007-Max"))
                minuteData.setF_nitrate_max(v);
            else if(ckey.equals("w01012-Max"))
                minuteData.setF_tss_max(v);
            else if(ckey.equals("w01018-Max"))
                minuteData.setF_cod_max(v);
            else if(ckey.equals("w01020-Max"))
                minuteData.setF_toc_max(v);
            else if(ckey.equals("w01019-Max"))
                minuteData.setF_permanganate_index_max(v);
            else if(ckey.equals("w01003-Max"))
                minuteData.setF_turbidity_max(v);
            else if(ckey.equals("DataTime"))
                minuteData.setF_time(v);
        }
        BaseResult result=minuteDataService.insert(minuteData);
        log.info("保存分钟数据结果={}",result);
    }
}
