package com.drht.datamanage.protocols;

import com.drhb.base.result.BaseResult;
import com.drht.datamanage.model.HourlyData;
import com.drht.datamanage.model.MinuteData;
import com.drht.datamanage.service.HourlyDataService;
import com.drht.datamanage.util.AnalysisUtil;
import com.drht.datamanage.model.msg.SendMsg;
import com.drht.datamanage.service.Reply;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelHandlerContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.*;
import java.util.List;

/**
 * 小时数据
 */
@Service
@Slf4j
public class Cn2601 implements Reply {
    @Autowired
    private HourlyDataService hourlyDataService;

    @Override
    public void rese(AnalysisUtil.Msg msg, ChannelHandlerContext ctx) throws ParseException {
        SendMsg sendMsg=new SendMsg();
        sendMsg.setQN(msg.getQN());
        sendMsg.setCN("9014");
        sendMsg.setPW(msg.getPW());//暂时写死
        sendMsg.setMN(msg.getMN());
        sendMsg.setFlag("8");
        sendMsg.setST("91");
        List<Map<String,Object>> CP=new ArrayList<>();
        Map cpMap=new HashMap();
        cpMap.put("QnRtn","1");
        CP.add(cpMap);
        sendMsg.setCP(CP);
        //编码报文
        String s = AnalysisUtil.KvToMsg(sendMsg,";");
        //回复消息
        ChannelFuture channelFuture = ctx.writeAndFlush(s);
        //小时数据入库
        Set set = msg.getCP().keySet();
        HourlyData hourlyData=new HourlyData();
        for (Object cpkey:set){
            String ckey=(String)cpkey;
            String v = (String) msg.getCP().get(ckey);
            if(ckey.equals("w21007-Min"))
                hourlyData.setF_nitrate_min(v);
            else if(ckey.equals("w01012-Min"))
                hourlyData.setF_tss_min(v);
            else if(ckey.equals("w01018-Min"))
                hourlyData.setF_cod_min(v);
            else if(ckey.equals("w01020-Min"))
                hourlyData.setF_toc_min(v);
            else if(ckey.equals("w01019-Min"))
                hourlyData.setF_permanganate_index_min(v);
            else if(ckey.equals("w01003-Min"))
                hourlyData.setF_turbidity_min(v);
            else if(ckey.equals("w21007-Avg"))
                hourlyData.setF_nitrate_avg(v);
            else if(ckey.equals("w01012-Avg"))
                hourlyData.setF_tss_avg(v);
            else if(ckey.equals("w01018-Avg"))
                hourlyData.setF_cod_avg(v);
            else if(ckey.equals("w01020-Avg"))
                hourlyData.setF_toc_avg(v);
            else if(ckey.equals("w01019-Avg"))
                hourlyData.setF_permanganate_index_avg(v);
            else if(ckey.equals("w01003-Avg"))
                hourlyData.setF_turbidity_avg(v);
            else if(ckey.equals("w21007-Max"))
                hourlyData.setF_nitrate_max(v);
            else if(ckey.equals("w01012-Max"))
                hourlyData.setF_tss_max(v);
            else if(ckey.equals("w01018-Max"))
                hourlyData.setF_cod_max(v);
            else if(ckey.equals("w01020-Max"))
                hourlyData.setF_toc_max(v);
            else if(ckey.equals("w01019-Max"))
                hourlyData.setF_permanganate_index_max(v);
            else if(ckey.equals("w01003-Max"))
                hourlyData.setF_turbidity_max(v);
            else if(ckey.equals("DataTime"))
                hourlyData.setF_time(v);
        }
        BaseResult result=hourlyDataService.insert(hourlyData);
        log.info("保存小时数据结果={}",result);
    }
}
